﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.Maps;

namespace C1MapswithGoogleTiles
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            foreach(var v in rbtnParent.Children)
            {
                RadioButton btn=v as RadioButton;
                if (btn!=null)
                    btn.Click+=new RoutedEventHandler(btn_Click); 
            }

            c1Maps.Source = new GoogleTilesSource("y");      //set default mode
          
        }

void  btn_Click(object sender, RoutedEventArgs e)
{
    RadioButton btn = sender as RadioButton;
    if ((btn != null) && (btn.Tag != null))
    {
        c1Maps.Source = new GoogleTilesSource(btn.Tag.ToString());
    }
    
}
    }

    public class GoogleTilesSource : C1MultiScaleTileSource
    {
        readonly Random rand = new Random();
     

        const string uriFormat = @"http://mt{0}.google.com/vt/lyrs={1}&z={2}&x={3}&y={4}";


        string _serverKey="1";   //google stores same tiles on 4 sources so as to load the balance. We have used server key as 1 here..


        //5 map modes for different map types 1)Hybrid("y") 2)Satellite("s") 3) Physical("t") 4)Street("m") 5)WaterOverlay("r")

        public string _mapMode = "y";      //set as default mode
     
        public GoogleTilesSource()
            : base(0x8000000, 0x8000000, 256, 256, 0)
        {
           
        }

        public GoogleTilesSource(string mapMode)
            : base(0x8000000, 0x8000000, 256, 256, 0)
        {
            _mapMode = mapMode;
        }


        protected override void GetTileLayers(int tileLevel, int tilePositionX, int tilePositionY, IList<object> sources)
        {
            if (tileLevel > 8)
            {
                sources.Add(new Uri(string.Format(uriFormat, _serverKey, _mapMode, tileLevel - 8, tilePositionX, tilePositionY)));
            }
        }
    }
}
